diff --git a/vhdlparser/VhdlParser.cc b/vhdlparser/VhdlParser.cc
index df9bbe5..66dc147 100644
--- a/vhdlparser/VhdlParser.cc
+++ b/vhdlparser/VhdlParser.cc
@@ -12801,16 +12806,26 @@ void VhdlParser::parseInline() {
 
  VhdlParser::VhdlParser(TokenManager *tm){
     head = NULL;
-    errorHandlerCreated = false;
     ReInit(tm);
 }
    VhdlParser::~VhdlParser()
 {
-  clear();
+  if (token_source) delete token_source;
+  if (head) {
+    Token *next, *t = head;
+    while (t) {
+      next = t->next;
+      delete t;
+      t = next;
+    }
+  }
+  if (errorHandlerCreated) {
+    delete errorHandler;
+  }
 }
 
 void VhdlParser::ReInit(TokenManager *tm){
-    clear();
+    if (head) delete head;
     errorHandler = new ErrorHandler();
     errorHandlerCreated = true;
     hasError = false;
@@ -12832,24 +12847,6 @@ void VhdlParser::ReInit(TokenManager *tm){
   }
 
 
-void VhdlParser::clear(){
-  //Since token manager was generate from outside,
-  //parser should not take care of deleting
-  //if (token_source) delete token_source;
-  if (head) {
-    Token *next, *t = head;
-    while (t) {
-      next = t->next;
-      delete t;
-      t = next;
-    }
-  }
-  if (errorHandlerCreated) {
-    delete errorHandler;
-  }
-}
-
-
 Token * VhdlParser::jj_consume_token(int kind)  {
     Token *oldToken;
     if ((oldToken = token)->next != NULL) token = token->next;
@@ -12872,8 +12869,7 @@ Token * VhdlParser::jj_consume_token(int kind)  {
     token = oldToken;
     jj_kind = kind;
     JAVACC_STRING_TYPE image = kind >= 0 ? tokenImage[kind] : tokenImage[0];
-    errorHandler->handleUnexpectedToken(kind, image.substr(1, image.size() - 2), getToken(1), this);
-    hasError = true;
+    errorHandler->handleUnexpectedToken(kind, image.substr(1, image.size() - 2), getToken(1), this), hasError = true;
     return token;
   }
 
@@ -12933,6 +12929,7 @@ int VhdlParser::jj_ntk_f(){
 void VhdlParser::jj_add_error_token(int kind, int pos)  {
   }
 
+  /** Generate ParseException. */
 
  void  VhdlParser::parseError()   {
       fprintf(stderr, "Parse error at: %d:%d, after token: %s encountered: %s\n", token->beginLine, token->beginColumn, addUnicodeEscapes(token->image).c_str(), addUnicodeEscapes(getToken(1)->image).c_str());
@@ -12942,6 +12939,8 @@ int VhdlParser::jj_ntk_f(){
  void VhdlParser::enable_tracing()  {
   }
 
+  /** Disable tracing. */
+
  void VhdlParser::disable_tracing()  {
   }
 
